VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "BufferClass"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Dim Buffer As Buffer

Public Property Get hdc() As Long
hdc = Buffer.hdc
End Property

Public Property Get Picture() As Long
Picture = Buffer.Picture
End Property

Public Property Get ScaleWidth() As Integer
ScaleWidth = Buffer.ScaleWidth
End Property

Public Property Let ScaleWidth(ByVal vNewValue As Integer)
Buffer.ScaleWidth = vNewValue
Class_Initialize
End Property

Public Property Get ScaleHeight() As Integer
ScaleHeight = Buffer.ScaleHeight
End Property

Public Property Let ScaleHeight(ByVal vNewValue As Integer)
Buffer.ScaleHeight = vNewValue
Class_Initialize
End Property

Public Property Get PenColor() As Long
PenColor = Buffer.PenColor
End Property

Public Property Let PenColor(ByVal vNewValue As Long)
Buffer.PenColor = vNewValue
UpdatePen
End Property

Public Property Get FontName() As String
FontName = Buffer.FontName
End Property

Public Property Let FontName(ByVal vNewValue As String)
Buffer.FontName = vNewValue
UpdateFont
End Property

Public Property Get FontBold() As Boolean
FontBold = Buffer.FontBold
End Property

Public Property Let FontBold(ByVal vNewValue As Boolean)
Buffer.FontBold = vNewValue
UpdateFont
End Property

Public Property Get FontItalic() As Boolean
FontItalic = Buffer.FontItalic
End Property

Public Property Let FontItalic(ByVal vNewValue As Boolean)
Buffer.FontItalic = vNewValue
UpdateFont
End Property

Public Property Get PenStyle() As PenStyle
PenStyle = Buffer.PenStyle
End Property

Public Property Let PenStyle(ByVal vNewValue As PenStyle)
Buffer.PenStyle = vNewValue
UpdatePen
End Property

Public Property Get FillStyle() As FillStyle
FillStyle = Buffer.FillStyle
End Property

Public Property Let FillStyle(ByVal vNewValue As FillStyle)
Buffer.FillStyle = vNewValue
UpdateBrush
End Property

Public Property Get FillColor() As Long
FillColor = Buffer.FillColor
End Property

Public Property Let FillColor(ByVal vNewValue As Long)
Buffer.FillColor = vNewValue
UpdateBrush
End Property

Public Property Get FillHatch() As FillHatch
FillHatch = Buffer.FillHatch
End Property

Public Property Let FillHatch(ByVal vNewValue As FillHatch)
Buffer.FillHatch = vNewValue
UpdateBrush
End Property

Public Property Get FontColor() As Long
FontColor = Buffer.FontColor
End Property

Public Property Let FontColor(ByVal vNewValue As Long)
Buffer.FontColor = vNewValue
UpdateFont
End Property

Public Property Get FontSize() As Integer
FontSize = Buffer.FontSize
End Property

Public Property Let FontSize(ByVal vNewValue As Integer)
Buffer.FontSize = vNewValue
UpdateFont
End Property

Public Property Get FontUnderline() As Boolean
FontUnderline = Buffer.FontUnderline
End Property

Public Property Let FontUnderline(ByVal vNewValue As Boolean)
Buffer.FontUnderline = vNewValue
UpdateFont
End Property

Public Property Get FontDegrees() As Integer
FontDegrees = Buffer.FontDegrees
End Property

Public Property Let FontDegrees(ByVal vNewValue As Integer)
Buffer.FontDegrees = vNewValue
UpdateFont
End Property

Public Property Get FontQuality() As FontQuality
FontQuality = Buffer.FontQuality
End Property

Public Property Let FontQuality(ByVal vNewValue As FontQuality)
Buffer.FontQuality = vNewValue
UpdateFont
End Property

Public Property Get DrawWidth() As Integer
DrawWidth = Buffer.DrawWidth
End Property

Public Property Let DrawWidth(ByVal vNewValue As Integer)
Buffer.DrawWidth = vNewValue
UpdatePen
End Property

Public Function PixelGet(X As Long, Y As Long) As Long
Point = GetPixel(Buffer.hdc, X, Y)
End Function

Public Sub PixelSet(X As Long, Y As Long, Color As Long)
SetPixelV Buffer.hdc, X, Y, Color
End Sub

Public Function PaintPicture(X As Long, Y As Long, nWidth As Long, nHeight As Long, hSrcDC As Long, xSrc As Long, ySrc As Long, dwRop As Rop) As Long

If dwRop = SRCALPHABLEND Then
Dim lBF&
CopyMemory lBF, Buffer.BlendAlpha, 4
PaintPicture = AlphaBlend(Buffer.hdc, X, Y, nWidth, nHeight, hSrcDC, xSrc, ySrc, nWidth, nHeight, lBF)
Exit Function
End If

PaintPicture = BitBlt(Buffer.hdc, X, Y, nWidth, nHeight, hSrcDC, xSrc, ySrc, dwRop)

End Function

Public Function LoadImage(Path As String) As Integer

Dim bmp As BITMAP

If FileLen(Path) = 0 Then Debug.Print Path: LoadImage = 1: Exit Function

Select Case LCase(Mid(Path, InStrRev(Path, ".") + 1, 3))
Case "bmp", "gif", "jpg", "pcx", "ico"

DeleteObject Buffer.Picture
Buffer.Picture = LoadImage(Path)
GetObjectAPI Buffer.Picture, Len(bmp), bmp

Buffer.ScaleWidth = bmp.bmWidthBytes
Buffer.ScaleHeight = bmp.bmHeight

If Buffer.Picture = 0 Then Class_Initialize: LoadImage = 3: Exit Function

SelectObject Buffer.hdc, Buffer.Picture
Buffer.HasPicture = True

Case Else: LoadImage = 2
End Select

End Function

Public Sub DeleteImage()

If Buffer.HasPicture = False Then Exit Sub

Buffer.HasPicture = False
Class_Initialize

End Sub

Public Function DrawFromBuffer(ByVal hDestDc As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal xSrc As Long, ByVal ySrc As Long, dwRop As Rop) As Long

If dwRop = SRCALPHABLEND Then
Dim lBF&
CopyMemory lBF, Buffer.BlendAlpha, 4
DrawFromBuffer = AlphaBlend(hDestDc, X, Y, nWidth, nHeight, Buffer.hdc, xSrc, ySrc, nWidth, nHeight, lBF)
Exit Function
End If

DrawFromBuffer = BitBlt(hDestDc, X, Y, nWidth, nHeight, Buffer.hdc, xSrc, ySrc, dwRop)

End Function

Public Function Ellipse(ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Ellipse = Ellipse2(Buffer.hdc, X1, Y1, X2, Y2)
End Function

Public Sub Cls()
FillRect Buffer.hdc, Buffer.Rect, Buffer.Brush
End Sub

Public Sub ScaleBuffer(ByVal Width As Integer, ByVal Height As Integer)

Buffer.ScaleWidth = Width
Buffer.ScaleHeight = Height
Class_Initialize

End Sub

Public Sub ProssesPicture(TableOnPixel() As Byte)

Dim pict() As Byte, A&
Dim sa As SAFEARRAY2D, bmp As BITMAP

GetObjectAPI Buffer.Picture, Len(bmp), bmp

With sa
.cbElements = 0
.cDims = 1
.Bounds(0).lLbound = 0
.Bounds(0).cElements = bmp.bmHeight * bmp.bmWidthBytes
.pvData = bmp.bmBits
End With

CopyMemory ByVal VarPtrArray(pict), VarPtr(sa), 4

For A = 0 To UBound(pict) Step 3
pict(A) = TableOnPixel(0, pict(A))
pict(A + 1) = TableOnPixel(1, pict(A))
pict(A + 2) = TableOnPixel(2, pict(A))
Next

CopyMemory ByVal VarPtrArray(pict), 0&, 4

End Sub

Public Function Rectangle(X1 As Long, Y1 As Long, X2 As Long, Y2 As Long) As Long
Rectangle = Rectangle2(Buffer.hdc, X1, Y1, X2, Y2)
End Function

Public Function BufferLine(ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long)

MoveToEx Buffer.hdc, X1, Y1, ByVal 0
LineTo Buffer.hdc, X2, Y2

End Function

Public Sub DrawText(X As Long, Y As Long, Text As String)
TextOut Buffer.hdc, X, Y, Text, Len(Text)
End Sub

Public Sub DrawArc(X1 As Long, Y1 As Long, X2 As Long, Y2 As Long, X3 As Long, Y3 As Long, X4 As Long, Y4 As Long)
Arc Buffer.hdc, X1, Y1, X2, Y2, X3, Y3, X4, Y4
End Sub

Public Sub InvertArea(X1 As Long, Y1 As Long, X2 As Long, Y2 As Long)

Dim Rect As Rect

With Rect
.Left = X1
.Top = Y1
.Right = X2
.Bottom = Y2
End With

InvertRect Buffer.hdc, Rect

End Sub

Public Function TextHeight() As Integer

TextHeight = -MulDiv(Buffer.FontSize, GetDeviceCaps(GetDC(0), LOGPIXELSY), 72)

End Function

Private Sub UpdateBrush()

Dim A As LOGBRUSH
DeleteObject Buffer.Brush

A.lbColor = Buffer.FillColor
A.lbStyle = Buffer.FillStyle
A.lbHatch = Buffer.FillHatch
Buffer.Brush = CreateBrushIndirect(A)
SetBkMode Buffer.hdc, Buffer.FillStyle
SelectObject Buffer.hdc, Buffer.Brush

End Sub

Private Sub UpdatePen()

DeleteObject Buffer.Pen
Buffer.Pen = CreatePen(Buffer.PenStyle, Buffer.DrawWidth, Buffer.PenColor)
SelectObject Buffer.hdc, Buffer.Pen

End Sub

Private Sub UpdateFont()

DeleteObject Buffer.Font
Buffer.Font = CreateFont(-MulDiv(Buffer.FontSize, GetDeviceCaps(GetDC(0), LOGPIXELSY), 72), 0, Buffer.FontDegrees * 10, 0, FW_NORMAL, Buffer.FontBold, Buffer.FontUnderline, Buffer.FontItalic, DEFAULT_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, Buffer.FontQuality, DEFAULT_PITCH, Buffer.FontName)
SetTextColor Buffer.hdc, Buffer.FontColor
SelectObject Buffer.hdc, Buffer.Font

End Sub

Private Sub Class_Initialize()

If Buffer.HasPicture = True Then Exit Sub

If Buffer.Created Then
DeleteDC Buffer.hdc
DeleteObject Buffer.Picture
End If

If Not Buffer.Created Then
Buffer.ScaleWidth = 100
Buffer.ScaleHeight = 100
Buffer.DrawWidth = 1
Buffer.FillHatch = HS_SOLID
Buffer.FontName = "Times New Roman"
Buffer.FontSize = 12
Buffer.FontQuality = PROOF_QUALITY
Buffer.PenStyle = PS_SOLID

UpdateBrush
UpdateFont
UpdatePen
End If

With Buffer.Rect
.Left = 0
.Top = 0
.Bottom = Buffer.ScaleHeight
.Right = Buffer.ScaleWidth
End With

Buffer.hdc = CreateCompatibleDC(GetWindowDC(GetDesktopWindow))
Buffer.Picture = CreateCompatibleBitmap(GetWindowDC(GetDesktopWindow), Buffer.ScaleWidth, Buffer.ScaleHeight)
SelectObject Buffer.hdc, Buffer.Picture

Buffer.Created = True

End Sub

Private Sub Class_Terminate()

DeleteDC Buffer.hdc
DeleteObject Buffer.Picture
DeleteObject Buffer.Pen
DeleteObject Buffer.Font
DeleteObject Buffer.Brush

End Sub

Public Property Get WindowFolder() As String

Dim A$

A = Space(255)
GetWindowsDirectory A, 255
WindowFolder = Mid(A, 1, InStr(1, A, " ") - 2)

End Property

Public Property Get SystemFolder() As String

Dim A$

A = Space(255)
GetSystemDirectory A, 255
SystemFolder = Mid(A, 1, InStr(1, A, " ") - 2)

End Property
